from numbers import Number

class SerieEntiere:
    def __init__(self, generateur):
        self.generateur = generateur
    def __repr__(self):
        it = self.generateur()
        return f"({next(it)}, {next(it)}, {next(it)}, ...)"
    def __iter__(self):
        return self.generateur()
    def __add__(self, other):
        def generateur():
            it = self.generateur()
            it2 = other.generateur()
            while True:
                yield next(it) + next(it2)
        def generateur():
            yield from map(sum, zip(self, other))
        return SerieEntiere(generateur)

    @classmethod
    def from_constant(cls, constant):
        def generateur():
            while True:
                yield constant
        return cls(generateur)

    def __mul__(self, other):
        if isinstance(other, Number):
            other = SerieEntiere.from_constant(other)
        def generateur():
            it = self.generateur()
            it2 = other.generateur()
            while True:
                yield next(it) * next(it2)
        def generateur():
            yield from map(lambda e:e[0]*e[1], zip(self, other))
            yield from map(lambda e,f: e*f, self, other)
        return SerieEntiere(generateur)

    def __neg__(self):
        def generateur():
            for x in self:
                yield -x
        def generateur():
            yield from map(lambda e:-e, self)
        return SerieEntiere(generateur)

    def __sub__(self, other):
        return self + (-other)

    def __rmul__(self, other):
        return self * other    

    def shift(self, indice):
        def generateur():
            it = iter(self)
            for i in range(indice):
                next(it)
            yield from it
        return SerieEntiere(generateur)

    def series(self):
        def generateur():
            s = 0
            for x in self:
                yield s
                s += x
        return SerieEntiere(generateur)

C1 = SerieEntiere.from_constant(3)
def identité():
    i = 0
    while True:
        yield i
        i+=1
N = SerieEntiere(identité)

def premier():
    P = set()
    n = 2
    while True:
        if not any(n%p == 0 for p in P):
            P.add(n)
            yield n
        n += 1    

P = SerieEntiere(premier)
